<?php
/**
 * Without template
 */
defined( 'ABSPATH' ) || exit; //Exit if accessed directly
?>
<div id="wffn_lp_edit_vue_wrap">
	<?php
	if ( class_exists( 'WFFN_Header' ) ) {
		$header_ins = new WFFN_Header();
		$header_ins->set_level_1_navigation_active( 'funnels' );
		ob_start();
		?>
		<div class="wf_funnel_card_switch">
			<label class="wf_funnel_switch">
				<input type="checkbox" <?php checked( 'publish', WFFN_Core()->landing_pages->get_status() ); ?>>
				<div class="wf_funnel_slider"></div>
			</label>
		</div>
		<?php
		$publisher = ob_get_contents();
		ob_end_clean();

		$header_ins->set_level_2_side_type('both');
		$header_ins->set_level_2_right_html($publisher);
		ob_start();
		?>
		<div class="bwf_breadcrumb">
				<div class="bwf_before_bre"></div>
				<?php BWF_Admin_Breadcrumbs::render_top_bar(); //phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
				<div class="bwf_after_bre">
					<a v-on:click="updateLanding()" href="javascript:void(0);" class="bwf_edt">
						<?php echo file_get_contents(  plugin_dir_path( WFFN_PLUGIN_FILE ) . 'admin/assets/img/icons/edit.svg'  ); //phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
					</a>
					<a v-bind:href="view_url" target="_blank" class="wffn-step-preview wffn-step-preview-admin">
						<?php echo file_get_contents(  plugin_dir_path( WFFN_PLUGIN_FILE ) . 'admin/assets/img/icons/view.svg'  ); //phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>
					</a>
				</div>
			</div>
		<?php
		$breadcrumb = ob_get_contents();
		ob_end_clean();
		$header_ins->set_level_2_post_title($breadcrumb); //used set_level_2_post_title as left inner html

		$header_nav_data = WFFN_Core()->landing_pages->admin->get_tabs_links( WFFN_Core()->landing_pages->get_edit_id() ); //navigation data
		$header_nav_data = array_column( $header_nav_data, null, 'section' );
		$header_ins->set_level_2_side_navigation( $header_nav_data ); //set header 2nd level navigation
		$header_ins->set_level_2_side_navigation_active( filter_var( $_GET['section'], FILTER_SANITIZE_STRING) );//phpcs:ignore

		echo $header_ins->render();//phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
	?>
	<div class="wrap">

		<!-- <?php WFFN_Core()->landing_pages->admin->get_tabs_html( WFFN_Core()->landing_pages->get_edit_id() ); ?> -->

		<div class="wffn-tabs-view-vertical wffn-widget-tabs">
			<div class="wffn-tabs-wrapper wffn-tab-center">
				<div class="wffn-tab-title wffn-tab-desktop-title additional_information_tab wffn-active" id="tab-title-additional_information" data-tab="1" role="tab" aria-controls="wffn-tab-content-additional_information">
					<?php esc_html_e( 'Custom CSS', 'funnel-builder' ); ?>
				</div>
				<div class="wffn-tab-title wffn-tab-desktop-title description_tab " id="tab-title-description" data-tab="2" role="tab" aria-controls="wffn-tab-content-description">
					<?php esc_html_e( 'External Scripts', 'funnel-builder' ); ?>
				</div>
				<?php do_action('wffn_landing_settings_tabs'); ?>
			</div>
			<div class="wffn-tabs-content-wrapper">
				<div class="wffn_custom_lp_setting_inner" id="wffn_global_setting">
					<form class="wffn_forms_wrap wffn_forms_global_settings ">
						<fieldset>
							<vue-form-generator :schema="schema" :model="model" :options="formOptions"></vue-form-generator>
						</fieldset>
						<div style="display: none" id="modal-global-settings_success" data-iziModal-icon="icon-home">
						</div>
					</form>
					<div class="bwf_form_button">
						<button v-on:click.self="onSubmit" style="float: left;" class="wffn_save_btn_style"><?php esc_html_e( 'Save changes', 'funnel-builder' ); ?></button>
						<span class="wffn_loader_global_save spinner" style="float: left;"></span>

					</div>
				</div>
			</div>
		</div>
	</div>


</div>
<?php
include_once dirname( __DIR__ ) . '/models/wffn-edit-landing.php';